Attribute VB_Name = "ModSurfaces"
Option Explicit
Public BackBuffer As DirectDrawSurface7
Public View As DirectDrawSurface7
Public Background As DirectDrawSurface7

Public SurfaceDesc As DDSURFACEDESC2

'objects
Public sprBlock As DirectDrawSurface7
Public sprBrick As DirectDrawSurface7
Public sprCoin(2) As DirectDrawSurface7
Public sprQuestionBlock(3) As DirectDrawSurface7
Public sprPipeV(12) As DirectDrawSurface7 'todo, maybe easier way, since most of pipe bmp is repeated)

'floor
Public sprFloor As DirectDrawSurface7

'player animations
'first half is for "small" player, second half for "big"
'later we can add "fire" mario
Public sprMarioRun(11) As DirectDrawSurface7 '0-2=small(L)  3-5=small(R)  6-8=big(L)  9-11=big(R)
Public sprMarioStand(3) As DirectDrawSurface7
Public sprMarioJump(3) As DirectDrawSurface7
Public sprMarioDuck(1) As DirectDrawSurface7

'enemy animations
Public sprGoomba(2) As DirectDrawSurface7
Public sprTurtleGreen(5) As DirectDrawSurface7

Public ViewDesc As DDSURFACEDESC2
Public BackBufferDesc As DDSURFACEDESC2
Public BackgroundDesc As DDSURFACEDESC2

Public BackBufferCaps As DDSCAPS2

Public ColorKey As DDCOLORKEY




'PREFIXES
' spr   =   sprite (DirectDrawSurface7)
' col   =   collision type


'COLOR SHIFT VALUES
Public RedShiftLeft As Long
Public RedShiftRight As Long
Public GreenShiftLeft As Long
Public GreenShiftRight As Long
Public BlueShiftLeft As Long
Public BlueShiftRight As Long


Public Sub GetColorShiftValues(PrimarySurface As DirectDrawSurface7)
    Dim PixelFormat As DDPIXELFORMAT
    PrimarySurface.GetPixelFormat PixelFormat
    MaskToShiftValues PixelFormat.lRBitMask, RedShiftRight, RedShiftLeft
    MaskToShiftValues PixelFormat.lGBitMask, GreenShiftRight, GreenShiftLeft
    MaskToShiftValues PixelFormat.lBBitMask, BlueShiftRight, BlueShiftLeft
End Sub
Public Sub MaskToShiftValues(ByVal Mask As Long, ShiftRight As Long, ShiftLeft As Long)
    Dim ZeroBitCount As Long
    Dim OneBitCount As Long

    ' Count zero bits
    ZeroBitCount = 0
    Do While (Mask And 1) = 0
        ZeroBitCount = ZeroBitCount + 1
        Mask = Mask \ 2 ' Shift right
    Loop

    ' Count one bits
    OneBitCount = 0
    Do While (Mask And 1) = 1
        OneBitCount = OneBitCount + 1
        Mask = Mask \ 2 ' Shift right
    Loop

    ' Shift right 8-OneBitCount bits
    ShiftRight = 2 ^ (8 - OneBitCount)
    ' Shift left ZeroBitCount bits
    ShiftLeft = 2 ^ ZeroBitCount
End Sub

Public Function DDRGB(Red As Long, Green As Long, Blue As Long) As Long
    DDRGB = (Red \ RedShiftRight) * RedShiftLeft + _
    (Green \ GreenShiftRight) * GreenShiftLeft + _
    (Blue \ BlueShiftRight) * BlueShiftLeft
End Function









Public Sub CreatePrimaryAndBackBuffer()
    'On Error GoTo ErrHandler
    
    Set View = Nothing
    Set BackBuffer = Nothing
    
    ViewDesc.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    ViewDesc.ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_FLIP Or DDSCAPS_COMPLEX
    ViewDesc.lBackBufferCount = 2 '1
    Set View = DX_Draw.CreateSurface(ViewDesc)
    
    BackBufferCaps.lCaps = DDSCAPS_BACKBUFFER
    Set BackBuffer = View.GetAttachedSurface(BackBufferCaps)
    BackBuffer.GetSurfaceDesc ViewDesc
    
    'BackBuffer.SetFontTransparency True 'todo
    
    GetColorShiftValues View
'    Exit Sub
'
'ErrHandler:
'    Debug.Print "CreateBuffers:  " & Err.Number & " - " & Err.Description
End Sub



Public Sub LoadAllPics()

    'TODO, WE COULD CREATE THE FACING-LEFT ANIMATIONS FROM THE FACING-RIGHT ONES
    'INSTEAD OF HAVING SPERATE BITMAPS FOR EACH
    
    'CreatePrimaryAndBackBuffer
    'GetColorShiftValues View
    
    'player
    Dim i As Long
    Dim fileheight As Long
    fileheight = TileSize
    For i = 0 To 11 'run
        If i = 6 Then fileheight = TileSize + TileSize
        CreateSurfaceFromFile sprMarioRun(i), SurfaceDesc, GraphicsPath & "MarioRun" & i & ".bmp", TileSize, fileheight
        AddColorKey sprMarioRun(i), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    Next
    fileheight = TileSize
    For i = 0 To 3 'stand
        If i = 2 Then fileheight = TileSize + TileSize
        CreateSurfaceFromFile sprMarioStand(i), SurfaceDesc, GraphicsPath & "MarioStand" & i & ".bmp", TileSize, fileheight
        AddColorKey sprMarioStand(i), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    Next
    fileheight = TileSize
    For i = 0 To 3 'jump
        If i = 2 Then fileheight = TileSize + TileSize
        CreateSurfaceFromFile sprMarioJump(i), SurfaceDesc, GraphicsPath & "MarioJump" & i & ".bmp", TileSize, fileheight
        AddColorKey sprMarioJump(i), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    Next
    'ducking
    CreateSurfaceFromFile sprMarioDuck(0), SurfaceDesc, GraphicsPath & "MarioDuck0.bmp", TileSize, PlayerBig
    AddColorKey sprMarioDuck(0), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprMarioDuck(1), SurfaceDesc, GraphicsPath & "MarioDuck1.bmp", TileSize, PlayerBig
    AddColorKey sprMarioDuck(1), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)

    
    
    'pipeV
    fileheight = TileSize
    For i = 0 To 12
        fileheight = fileheight + TileSize
        CreateSurfaceFromFile sprPipeV(i), SurfaceDesc, GraphicsPath & "PipeV" & i + 2 & ".bmp", TileSize * 2, fileheight
        AddColorKey sprPipeV(i), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    Next


    'goomba
    CreateSurfaceFromFile sprGoomba(0), SurfaceDesc, GraphicsPath & "Goomba0.bmp", 48, 48
    AddColorKey sprGoomba(0), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprGoomba(1), SurfaceDesc, GraphicsPath & "Goomba1.bmp", 48, 48
    AddColorKey sprGoomba(1), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprGoomba(2), SurfaceDesc, GraphicsPath & "GoombaSmashed.bmp", 48, 24
    AddColorKey sprGoomba(2), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)

    'turtle:green
    CreateSurfaceFromFile sprTurtleGreen(0), SurfaceDesc, GraphicsPath & "TurtleG0.bmp", 48, 72
    AddColorKey sprTurtleGreen(0), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprTurtleGreen(1), SurfaceDesc, GraphicsPath & "TurtleG1.bmp", 48, 72
    AddColorKey sprTurtleGreen(1), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprTurtleGreen(2), SurfaceDesc, GraphicsPath & "TurtleGShell0.bmp", 48, 72
    AddColorKey sprTurtleGreen(2), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprTurtleGreen(3), SurfaceDesc, GraphicsPath & "TurtleGShell1.bmp", 48, 72
    AddColorKey sprTurtleGreen(3), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprTurtleGreen(4), SurfaceDesc, GraphicsPath & "TurtleGShellUD0.bmp", 48, 72
    AddColorKey sprTurtleGreen(4), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprTurtleGreen(5), SurfaceDesc, GraphicsPath & "TurtleGShellUD1.bmp", 48, 72
    AddColorKey sprTurtleGreen(5), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    
    'coin
    CreateSurfaceFromFile sprCoin(0), SurfaceDesc, GraphicsPath & "Coin0.bmp", 48, 48
    AddColorKey sprCoin(0), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprCoin(1), SurfaceDesc, GraphicsPath & "Coin1.bmp", 48, 48
    AddColorKey sprCoin(1), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprCoin(2), SurfaceDesc, GraphicsPath & "Coin2.bmp", 48, 48
    AddColorKey sprCoin(2), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
 
    'question block
    CreateSurfaceFromFile sprQuestionBlock(0), SurfaceDesc, GraphicsPath & "QBlock0.bmp", 48, 48
    AddColorKey sprQuestionBlock(0), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprQuestionBlock(1), SurfaceDesc, GraphicsPath & "QBlock1.bmp", 48, 48
    AddColorKey sprQuestionBlock(1), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprQuestionBlock(2), SurfaceDesc, GraphicsPath & "QBlock2.bmp", 48, 48
    AddColorKey sprQuestionBlock(2), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)
    CreateSurfaceFromFile sprQuestionBlock(3), SurfaceDesc, GraphicsPath & "QBlock3.bmp", 48, 48
    AddColorKey sprQuestionBlock(3), ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)

    'block
    CreateSurfaceFromFile sprBlock, SurfaceDesc, GraphicsPath & "Block.bmp", 48, 48
    AddColorKey sprBlock, ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)

    'brick
    CreateSurfaceFromFile sprBrick, SurfaceDesc, GraphicsPath & "Brick.bmp", 48, 48
    AddColorKey sprBrick, ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)

    'floor
    CreateSurfaceFromFile sprFloor, SurfaceDesc, GraphicsPath & "Floor.bmp", 48, 72
    AddColorKey sprFloor, ColorKey, DDRGB(255, 0, 255), DDRGB(255, 0, 255)


End Sub


Public Sub UnloadAllPics()
    Set sprFloor = Nothing
    Set sprBlock = Nothing
    Set sprBrick = Nothing
    
    Dim i As Long
    For i = 0 To UBound(sprMarioStand)
        Set sprMarioStand(i) = Nothing
    Next
    For i = 0 To UBound(sprMarioJump)
        Set sprMarioJump(i) = Nothing
    Next
    For i = 0 To UBound(sprMarioRun)
        Set sprMarioRun(i) = Nothing
    Next
    For i = 0 To UBound(sprMarioDuck)
        Set sprMarioDuck(i) = Nothing
    Next
    For i = 0 To UBound(sprGoomba)
        Set sprGoomba(i) = Nothing
    Next
    For i = 0 To UBound(sprTurtleGreen)
        Set sprTurtleGreen(i) = Nothing
    Next
    For i = 0 To UBound(sprCoin)
        Set sprCoin(i) = Nothing
    Next
    For i = 0 To UBound(sprQuestionBlock)
        Set sprQuestionBlock(i) = Nothing
    Next
    For i = 0 To UBound(sprPipeV)
        Set sprPipeV(i) = Nothing
    Next
End Sub

Public Sub DestroyPrimaryAndBackBuffer()
    Set BackBuffer = Nothing
    Set View = Nothing
End Sub






